import java.io.*;

//dictionary class
class dict
{
        final static int MAX_WORDS = 4096*4;
        int numWords;  //# available words
        dictWord[] word = new dictWord[MAX_WORDS];

        //constructors
        public dict()
        {
                numWords = 0;
        }

        //add a new word to the list
        public void addWord(String str)
        {
                word[numWords++] = new dictWord(str);
        }

        //load the dictionary from a file
        public void loadFile(String filename)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", "");
                String[] tempStr = new String[MAX_WORDS];

                tempStr = tempStream.loadData(filename, MAX_WORDS);
                int count = 0;

                //keep going until there aren't any more words found in the string array
                while(tempStr[count] != null){
                        addWord(tempStr[count]);
                        count++;
                        }
        }

        //load the dictionary from any plain text file
        public void loadGenericFile(String filename)
        {
            numWords = 0;
            try{

				BufferedReader bufferedReader = null;
				FileReader fileReader = null;

                // FileReader reads text files in the default encoding.
                //FileReader fileReader = new FileReader(filename);
				// Always wrap FileReader in BufferedReader.
				//BufferedReader bufferedReader = new BufferedReader(fileReader);

                InputStream in = getClass().getResourceAsStream(filename);
				bufferedReader = new BufferedReader(new InputStreamReader(in));

                String line = null;
                while((line = bufferedReader.readLine()) != null)
                  {
                  addWord(line);
                  //System.out.println("Word #" + numWords + ": " + line + " loaded.");
                  }

                  // Always close files.
                  bufferedReader.close();
                }
            catch(FileNotFoundException ex)
                {
                System.out.println("Unable to open file '" + filename + "'");
                }
        catch(IOException ex)
              {
                System.out.println("Error reading file '" + filename + "'");
              }
        }

        //cut this line into an array of strings consisting of the component words
        public String[] parseLineStrings(String str, int maxWords)
        {
                String[] lineStr = new String[maxWords];

                int count = 0;
                int wCount = 0;
                String tempStr = str;
                tempStr.trim();
                while(count < tempStr.length()){
                        int curLen = 0;
                        while(characterIsWordComponent(tempStr.charAt(count))){
                                lineStr[wCount] += tempStr.charAt(count);
                                count++;
                                if(count >= tempStr.length()) break;
                                }
                        wCount++;
                        count++;
                        }
                return lineStr;
        }

        //tells if this word is present in the dictionary
        public boolean hasWord(String str)
        {
                for(int i = 0; i < numWords; i++){
                        if(word[i].txt.equals(str)) return true;
                        }
                return false;
        }

        //tells if this character is possible to be in a word
        public boolean characterIsWordComponent(char ch)
        {
                switch(Character.getType(ch)){
                        case Character.LETTER_NUMBER:
                        case Character.UPPERCASE_LETTER:
                        case Character.LOWERCASE_LETTER:
                        case Character.OTHER_LETTER:
                                return true;
                        default:
                                break;
                        }
                return false;
        }

        //remove the non-characters from this string and make it a regular word
        public String removeNonCharacters(String str)
        {
                String tempStr = new String(str);
                boolean done = false;
                int count = 0;

                while(!done){
                        if(!characterIsWordComponent(tempStr.charAt(count))){
                                //get the letters before the offending character
                                String tempStr2 = tempStr.substring(0, count);
                                String tempStr3 = tempStr.substring(count+1, tempStr.length());
                                //add the two ends, minus the offending char
                                tempStr = tempStr2 + tempStr3;
                                }
                        count++;
                        if(count >= tempStr.length()) done = true;
                        }

                return tempStr;
        }

        //get a random word
        public String getRandomWord(int minLen, int maxLen)
        {
                int randNo = (int)((float)Math.random()*(float)numWords);
                String tempStr = word[randNo].getString();
                //keep going until we get a string <= the length passed
                while(tempStr.length() > maxLen || tempStr.length() < minLen){
                        randNo = (int)((float)Math.random()*(float)numWords);
                        if(word[randNo] != null) tempStr = word[randNo].getString();
                        else tempStr = " ";
                        }

                return tempStr;
        }
}
