class hiScoreBank
{
        final static int MAX_MODES = 2;
        final static int MAX_SCORES = 256;
        final static int SORT_BYSCORE = 0;

        hiScore[][] score = new hiScore[MAX_MODES][MAX_SCORES];
        int[] numScores = new int[MAX_MODES];

        //constructors
        public hiScoreBank()
        {
                for(int i = 0; i < MAX_MODES; i++){
                        numScores[i] = 0;
                        }
        }

        //sort the scores.. (use heap sort..) sortflag tells what to sort by
        public void sort(int mode, int sortFlag)
        {
                //no need to sort if < 2 scores in the list..
                //ratio is (time)/(#words*wordlen)+8/wordlen
                if(numScores[mode] == 1 || numScores[mode] == 0) return;
                else if(numScores[mode] < 3){
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        if(score[mode][0].time > score[mode][1].time){
                                                hiScore tempHi = score[mode][0];
                                                score[mode][0] = score[mode][1];
                                                score[mode][1] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
                else{           
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        for(int i = 1; i < numScores[mode]; i++){
                                                hiScore tempHi = score[mode][i];
                                                int j = i;
                                                while(j > 0 && score[mode][j-1].time > tempHi.time){
                                                        score[mode][j] = score[mode][j-1];
                                                        j--;
                                                        }
                                                score[mode][j] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
        }

        //add a new score to the score list
        public void addNewScore(int mode, int sortFlag, String nm, long time, int numWords, int wordLength)
        {
                //make sure we don't go out of bounds here..
                if(numScores[mode] >= MAX_SCORES) numScores[mode]--;

                score[mode][numScores[mode]] = new hiScore();
                score[mode][numScores[mode]].name = nm;
                score[mode][numScores[mode]].time = time;
                score[mode][numScores[mode]].numWords = numWords;
                score[mode][numScores[mode]].wordLength = wordLength;
                numScores[mode]++;
        }

        //check to see if the data passed qualifies for a spot in the hiscore table
        public boolean isHiScoreTime(int mode, long tm)
        {
                //for(int i = numScores[mode]-1; i >= 0; i--){
                //        if(tm > score[mode][i].time) return true;
                //        }
                //return false;
                return true;
        }

        //load the scores from a file
        public void loadFile(int mode, String filename)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", "");
                String[] tempStr = new String[MAX_SCORES];

                System.out.println("loading data from remote server..");
                int numDataVars = 4;
                tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
                int count = 0;
                String[] tempStr2 = new String[numDataVars];
                numScores[mode] = 0;

                //keep going until there aren't any more words found in the string array
                while(tempStr[count*numDataVars] != null){
                        for(int i = 0; i < numDataVars; i++){
                                tempStr2[i] = tempStr[count*numDataVars+i];
                                System.out.println(tempStr2[i]);
                                }
                        addNewScore(mode, SORT_BYSCORE, tempStr2[0], Long.parseLong(tempStr2[1]), Integer.parseInt(tempStr2[2]), Integer.parseInt(tempStr2[3]));
                        count++;
                        }
        }

        //save the scores to a file
        public void saveFile(int mode, String wp)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", wp);

                int numDataVars = 4;
                String tempStr = "";
                for(int i = 0; i < numScores[mode]; i++){
                        tempStr += score[mode][i].name;
                        tempStr += "\n";
                        tempStr += score[mode][i].time;
                        tempStr += "\n";
                        tempStr += score[mode][i].numWords;
                        tempStr += "\n";
                        tempStr += score[mode][i].wordLength;
                        tempStr += "\n";
                        }
                System.out.println("Sending data to remote server..");
                try{
                        tempStream.sendData(tempStr);
                        }
                catch(Exception e){
                        System.out.println("an exception has occured:" + e.getMessage());
                        }
        }
}
