class tile
{
        final static int MODE_NORMAL = 0;
        final static int MODE_CROSSED = -1;
        final static int MODE_FADE_OUT = 1;
        final static int MODE_FADE_IN = 2;
        final static int MODE_SCALE_OUT = 3;
        final static int MODE_SCALE_IN = 4;

        char aChar;       //tile character
        int mode;         //current active mode
        vertex pos,vel;   //position, velocity vectors (in case we want some effects..)
        boolean wordHere; //tells if a word has a letter here
        boolean wordStart; //tells if a word starts here
        int wordLength;   //length of word, if any
        int wordDx, wordDy; //word X/Y direction
        int timer;        //timer for animation/fades/etc.

        //handle timer logic for different modes
        public void timerLogic()
        {
                switch(mode)
                {
                        case MODE_FADE_IN:
                              break;
                        case MODE_FADE_OUT:
                              break;
                        case MODE_SCALE_IN:
                              break;
                        case MODE_SCALE_OUT:
                              break;
                        default:
                              break;
                }
        }

        //handle tile logic
        public void logic()
        {
                timerLogic();
        }

        //some default values
        public void setDefault()
        {
                timer = 0;
                mode = MODE_NORMAL;
                wordHere = false;
                wordStart = false;
                wordLength = 0;
                wordDx = wordDy = 0;
        }

        //constructors
        public tile()
        {
                aChar = 'a';
                pos = new vertex();
                vel = new vertex(0.0f, 0.0f, 0.0f);
                setDefault();
        }
        public tile(char ch, int x, int y)
        {
                aChar = ch;
                pos = new vertex(x, y);
                vel = new vertex(0.0f, 0.0f, 0.0f);
                setDefault();
        }
        public tile(int x, int y)
        {
                aChar = 'a';
                pos = new vertex(x, y);
                vel = new vertex(0.0f, 0.0f, 0.0f);
                setDefault();
        }

        //set this as a word character
        public void setChar(char ch)
        {
                wordHere = true;
                aChar = ch;
        }

        //sets the char as a random a-z character
        public void setRandomChar()
        {
                int chInt = (int)(Math.random()*26)+(int)('a');
                aChar = (char)chInt;
                wordHere = false;
        }

        //is this tile crossed out?
        public boolean isCrossed()
        {
               return mode == MODE_CROSSED;
        }

        //cross this letter out
        public void crossOut()
        {
              mode = MODE_CROSSED;
        }
}
