/* this is a generic template that I use as a starting point for my java applets */
/* yeah, I'm that lazy */

//todo: when a word is found, highlight word on board, spawn particles
//todo: (done) increase spacing between letters on board
//todo: add other game modes (leftover letters, crooked words, etc.)

import java.applet.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;
import javax.swing.ImageIcon;

public class wordMix extends Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener
{
        //applet dimensions
        final static int APP_W = 640;
        final static int APP_H = 420;
        final static float FAPP_W = (float)APP_W;
        final static float FAPP_H = (float)APP_H;

        final static String VERSION_STRING = "Word Mix v02.03.2018a";

        final static int MIN_WORD_LENGTH = 4;

        final static int GAMESTATE_TITLE_INITIALIZE = -2;
        final static int GAMESTATE_TITLE = -1;
        final static int GAMESTATE_INITIALIZE = 0;
        final static int GAMESTATE_READY = 1;
        final static int GAMESTATE_LEVELUP = 2;
        final static int GAMESTATE_GAMEOVER_BEGIN = 3;
        final static int GAMESTATE_GAMEOVER = 4;

        final static int MAX_PLAYER_NAME_LENGTH = 32;

        //misc. settings
        boolean isApplication = true;
        boolean useFullscreen = false; //full-screen or windowed?
        boolean isOnline = false;     //are we playing in a browser?
        boolean upperCaseOn = true;  //toggles uppercase letters
        boolean debugOn = false;     //toggles debug display
        boolean loadingPuzzle = false;  //tells when a puzzle is currently being set up and loaded into memory
        boolean showQuitPrompt = false; //tells if the "really quit?" prompt is showing
        boolean showTimeUpPrompt = false; //tells if the "times up" prompt is showing
        boolean puzzleFinished = false; //tells when the puzzle has been completed (all words crossed out)
        boolean continueAnyway = false; //tells if the player has chosent to continue the game anyway, after time has expired
        int timeLimitSel = 0;        //time limit selection (0 is infinite)
        int numWordsSel = 3;         //# words selection
        int wordLengthSel = 4;       //word length cap selection

        //int gameState = GAMESTATE_INITIALIZE;
        int gameState = GAMESTATE_TITLE_INITIALIZE;

        //heads up display dimensions
        int hudW = APP_W;
        int hudH = 40;

        //playing area dimensions
        int playW = APP_W;
        int playH = APP_H-hudH;

        int curScoringMode = 0;
        boolean gotHiScore = false;
        boolean hiScoreEntryDone = false;

        //misc. positioning/ui stuff
        vertex playFieldPos;
        vertex hudPos = new vertex(0.0f, FAPP_H-(float)hudH);   //placement of the heads up display (score, etc.)
        vertex hudEnergyPos = new vertex(79, 7);
        vertex hudScorePos = new vertex(55, 14);
        vertex hudHiScorePos = new vertex(55, 32);
        vertex hudLevelPos = new vertex(375, 18);
        vertex hudClockPos = new vertex(APP_W-40, APP_H-2);

        //quit prompt stuff
        vertex quitPromptPos = new vertex(APP_W/2-100, APP_H/2-40);
        int quitPromptW = 200;
        int quitPromptH = 80;
        boolean quitPromptYesOver = false;
        boolean quitPromptNoOver = false;

        //time's up prompt stuff
        vertex timeUpPromptPos = new vertex(APP_W/2-160, APP_H/2-80);
        int timeUpPromptW = 320;
        int timeUpPromptH = 160;
        boolean timeUpPromptYesOver = false;
        boolean timeUpPromptNoOver = false;

        //puzzle finished stuff
        vertex puzzleFinishedPos = new vertex(APP_W/2-200, APP_H/2-100);
        int finishedPromptW = 400;
        int finishedPromptH = 200;
        boolean finishedPromptYesOver = false;
        boolean finishedPromptNoOver = false;

        //title stuff
        String titleLogoStr = "    ( w o r d m i x )";
        String titleNWStr =   "              ( # words )";
        String titleWLStr =   "            ( longest word )";
        String titleTLStr =   "             ( time limit )";
        String titlePlayStr = "          ( play )";
        vertex titlePos = new vertex(20, 20);
        vertex titleLogoPos = new vertex(160, 32);
        vertex titleNWPos = new vertex(160, 93);
        vertex titleWLPos = new vertex(160, 173);
        vertex titleTLPos = new vertex(160, 258);
        vertex titlePlayPos = new vertex(160, 355);

        //use these to tell when mouse is over various items
        boolean titlePlayOver = false;
        int titleNWOver = -1;
        int titleWLOver = -1;
        int titleTLOver = -1;

        //title menu dimensions
        int titleW = APP_W-40;
        int titleH = APP_H-40;
        Color titleColor = new Color(0.925f, 0.925f, 0.925f);

        //hiscore entry stuff
        String playerNameString = ""; //player name string for hiscore entry

        Thread mainThread = null;     //main thread
        Color borderClearColor = new Color(255, 255, 255);  //border background color
        Color clearColor = new Color(1.0f, 1.0f, 1.0f);  //background color
        Color gridColor = new Color(0.75f, 0.75f, 0.75f);
        Color hudColor = new Color(0.6f,0.6f,0.6f,1.0f);   //the color used for the heads up display

        Image img_scBuff = null;         //screen buffer
        Graphics g_scBuff = null;        //screen buffer graphics context
        Font gameFont = null;
        Font hudFont = null;
        int fontW = 16, fontH = 16;
        //int fontW = 8, fontH = 10;
//        Font mySpecialFont = Font.createFont(Font.TRUETYPE_FONT, getClass().getResourceAsStream("myfont.ttf"));
        Image hudImage = null;           //heads up display bitmap

        AverageTimer gameAverageTimer = null;   //average time for display sync

        clock gameClock = new clock();           //game clock

        hiScoreBank gameHiScoreBank = new hiScoreBank();  //game high scores listings

        puzzle gamePuzzle = null;                //the puzzle..
        String puzzFilename = "";                //the filename of the current puzzle (to be loaded?)

        dict gameDictionary = null;              //main game word bank

        player gamePlayer = null;                //game player..

        particleBank gameParticleBank = new particleBank();    //game particle bank

        //applet init sequence
        public void init()
        {
                setBackground(clearColor);  //set bg color
                resize(APP_W, APP_H);       //set applet dimensions

                //create screen buffer
                try{
                        img_scBuff = createImage(APP_W, APP_H);
                        g_scBuff = img_scBuff.getGraphics();
                        }
                catch(Exception e){
                        System.out.println("screen buffer not created..");
                        img_scBuff = null;
                        g_scBuff = null;
                        return;
                        }

                g_scBuff.setColor(clearColor);
                g_scBuff.fillRect(0, 0, APP_W, APP_H);

                //add listeners
                addMouseListener(this);
                addMouseMotionListener(this);
                addKeyListener(this);

                //load saved hiscores
        }

        //start the main thread
        public void start()
        {
                if(mainThread == null){
                        mainThread = new Thread(this);
                        mainThread.start();   //invokes run()
                        }
        }

        //kill the main thread
        public void stop()
        {
                mainThread = null;
        }

        //draw stuff to the screen
        public void paint(Graphics g)
        {
                if(img_scBuff != null){
                        g.drawImage(img_scBuff, 0, 0, this);  //draw the screen buffer to the graphics context
                        }
        }

        //update the supplied graphics context
        public void update(Graphics g)
        {
                paint(g);
        }

        public void run()
        {
                System.out.println("applet starting...");

                if(g_scBuff == null) return; //make sure double buffer created properly

                Graphics g = getGraphics();

                //register font
                g.setFont(gameFont);
                g_scBuff.setFont(gameFont);

                //make sure initialization occurs without incident
                if(!initApp(g)) return;

                System.out.println("entering main loop...");

                //keep looping until the thread is killed
                while(mainThread != null){
                        updateApp();  //handle logic
                        paintApp(g);  //handle display

                        try{   //take a little nap
                                Thread.sleep(10);
                                }catch(InterruptedException e) { stop(); }
                        }

                System.out.println("applet cleanly exited.");
        }

        //load the game dictionary file
        void loadGameDictionary()
        {
                gameDictionary = new dict();
                if(isOnline){
                        gameDictionary.loadFile("/wordMix/dict.txt");
                        }
		            else{
                      gameDictionary.loadGenericFile("dict.txt");
			               }
        }

        //load all the images up before we start going
        void loadGameImages(Graphics g)
        {
        }

        //set the hiscore stuff up
        void initializeHiScoreStuff()
        {
                if(isOnline){
                        loadHiScores();
                        }
                //setDummyScoreboard();
        }

        //applet initialization sequence
        boolean initApp(Graphics g)
        {
                //start the average timer..
                gameAverageTimer = new AverageTimer( System.currentTimeMillis() );

                //register the font
                gameFont = new Font("monospaced", Font.BOLD, fontH);
                hudFont = new Font("sansserif", Font.BOLD, 10);

                //g.drawString("Loading game images..", 0, fontH*2);
                //load game image files
                loadGameImages(g);

                //load game dictionary..
                g.drawString("Loading game dictionary..", 0, fontH*4);
                loadGameDictionary();

                //set the hiscore-related stuff up
                g.drawString("Loading hiscores from server..", 0, fontH*6);
                initializeHiScoreStuff();

                //ah! success!
                return true;
        }

        //keyboard listener stuff
        public void keyPressed(KeyEvent e){
                if(gameState == GAMESTATE_READY){
                        if(puzzleFinished && !hiScoreEntryDone){
                                if(e.getKeyCode() == KeyEvent.VK_ENTER){
                                        finishHiScoreEntry();
                                        }
                                }
                        }
                else if(gameState == GAMESTATE_GAMEOVER){
                        }
                }
        public void keyReleased(KeyEvent e){
                }
        public void keyTyped(KeyEvent e){
                switch(gameState){
                        case GAMESTATE_READY:
                                if(puzzleFinished && !hiScoreEntryDone){
                                        //backspace.. erase last letter
                                        if(e.getKeyChar() == (char)8){
                                                if(playerNameString.length() > 0){
                                                        int len = playerNameString.length();
                                                        String str = playerNameString.substring(0, len-1);
                                                        playerNameString = str;
                                                        }
                                                }
                                        else if(e.getKeyCode() == KeyEvent.VK_ENTER){
                                                finishHiScoreEntry();
                                                }
                                        else playerNameString += e.getKeyChar();
                                        }
                                break;
                        default:
                                break;
                        }
                }

        //mouse listener stuff
        public void mousePressed(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_READY:
                                if(gamePuzzle.pointWithinBoard(e.getX(), e.getY())){
                                        //left click starts crossing a word out..
                                        if(e.getButton() == MouseEvent.BUTTON1){
                                                gamePlayer.colStart = (e.getX()-(int)gamePuzzle.boardPos.x)/gamePuzzle.tileW;
                                                gamePlayer.rowStart = (e.getY()-(int)gamePuzzle.boardPos.y)/gamePuzzle.tileH;

                                                //place the start coords in the middle of the current tagged tile
                                                gamePlayer.startX = gamePlayer.colStart*gamePuzzle.tileW+gamePuzzle.tileW/2;
                                                gamePlayer.startY = gamePlayer.rowStart*gamePuzzle.tileH+gamePuzzle.tileH/2;

                                                //set the ending points as the same
                                                gamePlayer.colStart2 = gamePlayer.colStart;
                                                gamePlayer.rowStart2 = gamePlayer.rowStart;
                                                gamePlayer.colEnd = gamePlayer.colStart;
                                                gamePlayer.rowEnd = gamePlayer.rowStart;
                                                gamePlayer.endX = gamePlayer.startX;
                                                gamePlayer.endY = gamePlayer.startY;
                                                gamePlayer.dx = gamePlayer.dy = 0;

                                                gamePlayer.setDrawOn();
                                                }
                                        //right mouse button marks a letter
                                        else if(e.getButton() == MouseEvent.BUTTON3){
                                                }
                                        }
                                break;
                        default:
                                break;
                        }
        }
        public void mouseClicked(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_TITLE:  //start the game on click
                                //"play" clicked, start game
                                if(titlePlayOver){
                                        gameState = GAMESTATE_INITIALIZE;
                                        }
                                if(titleNWOver > -1){
                                        numWordsSel = titleNWOver;
                                        titleNWOver = -1;
                                        }
                                if(titleWLOver > -1){
                                        wordLengthSel = titleWLOver;
                                        titleWLOver = -1;
                                        }
                                if(titleTLOver > -1){
                                        timeLimitSel = titleTLOver;
                                        titleTLOver = -1;
                                        }

                                break;
                        case GAMESTATE_GAMEOVER:  //restart the game on click
                                gameState = GAMESTATE_INITIALIZE;

                                break;
                        case GAMESTATE_READY:  //check in-game menu clicks
                                int x = e.getX(), y = e.getY();

                                //don't handle clicks if we're within the game board..
                                if((!showQuitPrompt && gamePuzzle.pointWithinBoard(x, y)) && !showTimeUpPrompt) return;

                                else if(showQuitPrompt){
                                        if(quitPromptYesOver){
                                                gameState = GAMESTATE_TITLE_INITIALIZE;  //exit the game, go back to title
                                                showQuitPrompt = false;
                                                }
                                        else if(quitPromptNoOver){
                                                showQuitPrompt = false;
                                                }

                                        return;  //no reason to check further if prompt is showing
                                        }

                                else if(showTimeUpPrompt){
                                        if(timeUpPromptYesOver){
                                                gameState = GAMESTATE_TITLE_INITIALIZE;  //exit the game, go back to title
                                                showTimeUpPrompt = false;
                                                }
                                        else if(timeUpPromptNoOver){
                                                showTimeUpPrompt = false;
                                                continueAnyway = true;
                                                }

                                        return;  //no reason to check further if prompt is showing
                                        }

                                //handle caps toggle press
                                if(gamePuzzle.onCapsButton()){
                                        upperCaseOn = !upperCaseOn;
                                        //gamePuzzle.setCapsOver(false);
                                        }
                                //handle restart press
                                else if(gamePuzzle.onResetButton()){
                                        showQuitPrompt = true;
                                        //gamePuzzle.setResetOver(false);
                                        }
                                //handle debug toggle press
                                else if(gamePuzzle.onDebugButton()){
                                        debugOn = !debugOn;
                                        gamePuzzle.setDebug(debugOn);
                                        //gamePuzzle.setResetOver(false);
                                        }
                                break;
                        default:
                                break;
                        }
        }

        public void mouseEntered(MouseEvent e){ }
        public void mouseExited(MouseEvent e){ }
        public void mouseReleased(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_READY:
                                String tempStr = gamePlayer.getSelectionString(gamePuzzle);
                                if(gamePuzzle.hasWordActive(tempStr)){
                                        crossOutPuzzleWord(tempStr);
                                        gamePlayer.markSelectionString(gamePuzzle);
                                        //spawn particles
                                        //gameParticleBank.spawnRectFilledParticleCluster(gamePuzzle.pos, Color.GREEN, 3, 4, 5);
                                        }
                                gamePlayer.setDrawOff();
                                break;
                        default:
                                break;
                        }
        }

        public void mouseDragged(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_READY:
                                if(showQuitPrompt || puzzleFinished) return;   //exit out if the quit prompt is showing
                                if(gamePuzzle.pointWithinBoard(e.getX(), e.getY())){
                                        int newCol = (e.getX()-(int)gamePuzzle.boardPos.x)/gamePuzzle.tileW;
                                        int newRow = (e.getY()-(int)gamePuzzle.boardPos.y)/gamePuzzle.tileH;

                                        gamePlayer.rowEnd = newRow;
                                        gamePlayer.colEnd = newCol;

                                        //place the start coords in the middle of the current tagged tile
                                        gamePlayer.endX = gamePlayer.colEnd*gamePuzzle.tileW+gamePuzzle.tileW/2;
                                        gamePlayer.endY = gamePlayer.rowEnd*gamePuzzle.tileH+gamePuzzle.tileH/2;

                                        //set the x/y slope
                                        gamePlayer.setSelectionSlope();
                                        }
                                break;
                        default:
                                break;
                        }
        }
/*
        public void mouseDragged(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_READY:
                                if(gamePuzzle.pointWithinBoard(e.getX(), e.getY())){
                                        int newCol = (e.getX()-(int)gamePuzzle.boardPos.x)/gamePuzzle.tileW;
                                        int newRow = (e.getY()-(int)gamePuzzle.boardPos.y)/gamePuzzle.tileH;

                                        //if the start and end rows are the same, and the new ones are different, find the dx and dy..
                                        if(gamePlayer.colEnd == gamePlayer.colStart && gamePlayer.rowEnd == gamePlayer.rowStart){
                                                if(newCol != gamePlayer.colEnd || newRow != gamePlayer.rowEnd){
                                                        gamePlayer.dx = newCol-gamePlayer.colEnd;
                                                        gamePlayer.dy = newRow-gamePlayer.rowEnd;
                                                        gamePlayer.colEnd = newCol;
                                                        gamePlayer.rowEnd = newRow;
                                                        }
                                                }
                                        else{
                                                if(gamePlayer.dx < 0){
                                                        if(newCol < gamePlayer.colStart){
                                                                gamePlayer.colEnd = newCol;
                                                                }
                                                        }
                                                else if(gamePlayer.dx > 0){
                                                        if(newCol > gamePlayer.colStart){
                                                                gamePlayer.colEnd = newCol;
                                                                }
                                                        }
                                                else if(gamePlayer.dx == 0){
                                                        if(newCol == gamePlayer.colEnd){
                                                                gamePlayer.colEnd = newCol;
                                                                }
                                                        }
                                                if(gamePlayer.dy < 0){
                                                        if(newRow < gamePlayer.rowStart){
                                                                gamePlayer.rowEnd = newRow;
                                                                }
                                                        }
                                                else if(gamePlayer.dy > 0){
                                                        if(newRow > gamePlayer.rowStart){
                                                                gamePlayer.rowEnd = newRow;
                                                                }
                                                        }
                                                else if(gamePlayer.dy == 0){
                                                        if(newRow == gamePlayer.rowEnd){
                                                                gamePlayer.rowEnd = newRow;
                                                                }
                                                        }
                                                }

                                        //place the start coords in the middle of the current tagged tile
                                        gamePlayer.endX = gamePlayer.colEnd*gamePuzzle.tileW+gamePuzzle.tileW/2;
                                        gamePlayer.endY = gamePlayer.rowEnd*gamePuzzle.tileH+gamePuzzle.tileH/2;
                                        }
                                break;
                        default:
                                break;
                        }
        }
*/

        public void mouseMoved(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_TITLE:
                                int x = e.getX();
                                int y = e.getY();
                                //check against play button
                                if(x >= APP_W/2-40 && x <= APP_W/2+40 && y >= (int)(titlePos.y+titlePlayPos.y)-20 && y <= (int)(titlePos.y+titlePlayPos.y)+10){
                                        titlePlayOver = true;
                                        }
                                else{
                                        titlePlayOver = false;
                                        }
                                //check against # words menu
                                if(x >= APP_W/2-150 && x <= APP_W/2+150 && y >= (int)(titlePos.y+titleNWPos.y)+5 && y <= (int)(titlePos.y+titleNWPos.y)+30){
                                        //titleNWOver = (APP_W/2+150-x)/40;
                                        titleNWOver = Math.abs(7-(APP_W/2+150-x)/40);
                                        }
                                else{
                                        titleNWOver = -1;
                                        }
                                //check against word length menu
                                if(x >= APP_W/2-180 && x <= APP_W/2+160 && y >= (int)(titlePos.y+titleWLPos.y)+5 && y <= (int)(titlePos.y+titleWLPos.y)+30){
                                        titleWLOver = Math.abs(10-(APP_W/2+200-x)/35);
                                        }
                                else{
                                        titleWLOver = -1;
                                        }
                                //check against time limit menu
                                if(x >= APP_W/2-120 && x <= APP_W/2+120 && y >= (int)(titlePos.y+titleTLPos.y)+5 && y <= (int)(titlePos.y+titleTLPos.y)+30){
                                        titleTLOver = Math.abs(4-(APP_W/2+120-x)/50);
                                        }
                                else{
                                        titleTLOver = -1;
                                        }

                                break;
                        case GAMESTATE_READY:
                                int rx = e.getX(), ry = e.getY();
                                //don't do anything if we're within the board
                                if((!showQuitPrompt && gamePuzzle.pointWithinBoard(rx, ry)) || puzzleFinished) return;

                                else if(showQuitPrompt){
                                        //within the 'yes' button
                                        if(rx >= (int)quitPromptPos.x+20 && rx <= (int)quitPromptPos.x+90 && ry >= (int)quitPromptPos.y+50 && ry <= (int)quitPromptPos.y+70){
                                                quitPromptYesOver = true;
                                                }
                                        else quitPromptYesOver = false;

                                        //within 'no' button
                                        if(rx >= (int)quitPromptPos.x+120 && rx <= (int)quitPromptPos.x+180 && ry >= (int)quitPromptPos.y+50 && ry <= (int)quitPromptPos.y+70){
                                                quitPromptNoOver = true;
                                                }
                                        else quitPromptNoOver = false;

                                        return;   //don't bother checking the other stuff if the quit prompt is showing
                                        }

                                else if(showTimeUpPrompt){
                                        //within the 'exit' button
                                        if(rx >= (int)timeUpPromptPos.x+110 && rx <= (int)timeUpPromptPos.x+190 && ry >= (int)timeUpPromptPos.y+65 && ry <= (int)timeUpPromptPos.y+85){
                                                timeUpPromptYesOver = true;
                                                }
                                        else timeUpPromptYesOver = false;

                                        //within 'no' button
                                        if(rx >= (int)timeUpPromptPos.x+70 && rx <= (int)timeUpPromptPos.x+255 && ry >= (int)timeUpPromptPos.y+85 && ry <= (int)timeUpPromptPos.y+105){
                                                timeUpPromptNoOver = true;
                                                }
                                        else timeUpPromptNoOver = false;

                                        return;   //don't bother checking the other stuff if the quit prompt is showing
                                        }

                                if(gamePuzzle.pointWithinCapsButton(rx, ry)){
                                        if(!gamePuzzle.onCapsButton()){
                                                gamePuzzle.setCapsOver(true);
                                                }
                                        }
                                else gamePuzzle.setCapsOver(false);

                                if(gamePuzzle.pointWithinResetButton(rx, ry)){
                                        if(!gamePuzzle.onResetButton()){
                                                gamePuzzle.setResetOver(true);
                                                }
                                        }
                                else gamePuzzle.setResetOver(false);

                                if(gamePuzzle.pointWithinDebugButton(rx, ry)){
                                        if(!gamePuzzle.onDebugButton()){
                                                gamePuzzle.setDebugOver(true);
                                                }
                                        }
                                else gamePuzzle.setDebugOver(false);

                                break;
                        default:
                                break;
                        }
        }

        //draw the debris/particles..
        void particleDisplay(Graphics g, particleBank pb)
        {
            for(int i = 0; i < pb.numParticles; i++)
            {
                if(pb.bParticle[i] == null || pb.bParticle[i].isInactive()) continue;  //skip over inactive particles
                if(pb.bParticle[i].isCircle())
                {
                    g.setColor(pb.bParticle[i].color);
                    g.drawOval((int)(pb.bParticle[i].pos.x-pb.bParticle[i].hRad)-pb.bParticle[i].c1/(pb.bParticle[i].c3*2), (int)(int)(pb.bParticle[i].pos.y-pb.bParticle[i].vRad)-pb.bParticle[i].c1/(pb.bParticle[i].c3*2), (int)pb.bParticle[i].hRad*2+pb.bParticle[i].c1/pb.bParticle[i].c3, (int)pb.bParticle[i].vRad*2+pb.bParticle[i].c1/pb.bParticle[i].c3);
                }
                else if(pb.bParticle[i].isCircleFilled())
                {
                    g.setColor(pb.bParticle[i].color);
                    g.fillOval((int)(pb.bParticle[i].pos.x-pb.bParticle[i].hRad), (int)(pb.bParticle[i].pos.y-pb.bParticle[i].vRad), (int)pb.bParticle[i].hRad*2, (int)pb.bParticle[i].vRad*2);
                }
                else if(pb.bParticle[i].isText())
                {
                    if(pb.bParticle[i].isTextBig())
                    {
                        Font bigFont = gamePuzzle.font.jFont.deriveFont(Font.PLAIN, fontH*2);
                        g.setFont(bigFont);
                    }
                    else g.setFont(gameFont);
                    g.setColor(pb.bParticle[i].color);
                    drawStringShadowed(g, pb.bParticle[i].txt, pb.bParticle[i].color, (int)pb.bParticle[i].pos.x, (int)pb.bParticle[i].pos.y, 2, 2);
                    g.setFont(gameFont);
                }
            }
        }



        //draw the clock all digital-like
        void clockDisplay(Graphics g, clock co, int x, int y, Color color, int fontSize)
        {
                Font clockFont = gamePuzzle.font.jFont.deriveFont(Font.PLAIN, fontSize);
                g.setFont(clockFont);
                g.setColor(color);
                g.drawString("" + intNumberString(co.mins, 2) + ":" + intNumberString(co.secs, 2), x, y);
        }

        //handle puzzle drawing stuff
        void puzzleDisplay(Graphics g, puzzle pz)
        {
                pz.draw(g, this, APP_W, APP_H, upperCaseOn);
        }

        //handle player drawing stuff
        void playerDisplay(Graphics g, player pl, puzzle pz)
        {
                if(pl.isDrawing()){
                        //float slope = (float)(pl.rowEnd-pl.rowStart)/(pl.colEnd-pl.colStart);
                        g.setColor(Color.red);
                        if(pl.hasDirection()){
                                int c = pl.colStart;
                                int r = pl.rowStart;
                                while((c != pl.colEnd || r != pl.rowEnd) && c < pz.numCols && r < pz.numRows){
                                        g.drawRect((int)(pz.boardPos.x)+c*pz.tileW, (int)(pz.boardPos.y)+r*pz.tileH, pz.tileW, pz.tileH);
                                        c += pl.dx;
                                        r += pl.dy;
                                        }
                                if(c < pz.numCols && r < pz.numRows) g.drawRect((int)(pz.boardPos.x)+c*pz.tileW, (int)(pz.boardPos.y)+r*pz.tileH, pz.tileW, pz.tileH);
                                //g.drawRect((int)(pz.boardPos.x)+pl.colEnd*pz.tileW, (int)(pz.boardPos.y)+pl.rowEnd*pz.tileH, pz.tileW, pz.tileH);
                                }
                        else{
                                }
                        }
        }

        //handle drawing the items
        void itemDisplay(Graphics g, item it[], int numItems)
        {
        }

        //draw the grid overlay (if we use it?)
        void gridDisplay(Graphics g)
        {
        }

        //draw the scrolling backdrop
        void backgroundDisplay(Graphics g)
        {
                //draw the play area
                g.setColor(clearColor);
                g.fillRect(0, 0, APP_W, APP_H);

                //draw a border around the applet window
                g.setColor(new Color(0.85f, 0.85f, 0.85f));
                g.drawRect(0, 0, APP_W-1, APP_H-1);
        }

        //draw the hud/status stuff
        void foregroundDisplay(Graphics g)
        {
        }

        //show status updates while game is initializing
        void gameInitializationDisplay(Graphics g)
        {
                if(loadingPuzzle){
                        g.setColor(Color.black);
                        g.drawString("generating puzzle.. please wait..", 0, 0);
                        }
        }

        //draw the title screen
        void titleDisplay(Graphics g)
        {
                //draw the title menu
                g.setColor(titleColor);
                g.fillRect((int)titlePos.x+1, (int)titlePos.y+1, titleW+1, titleH+1);
                g.setColor(titleColor);
                g.fillRect((int)titlePos.x, (int)titlePos.y, titleW, titleH);
                g.setColor(Color.black);
                g.drawRect((int)titlePos.x, (int)titlePos.y, titleW, titleH);

                //draw the logo
                g.setFont(new Font("monospaced", Font.PLAIN, 18));
                g.drawString(titleLogoStr, (int)(titlePos.x+titleLogoPos.x), (int)(titlePos.y+titleLogoPos.y));

                g.setFont(new Font("monospaced", Font.PLAIN, 12));
                //draw the # words selection stuff
                g.drawString(titleNWStr, (int)(titlePos.x+titleNWPos.x), (int)(titlePos.y+titleNWPos.y));
                g.setColor(Color.white);
                g.fillRect((int)(titlePos.x+titleNWPos.x)+40*numWordsSel-10, (int)(titlePos.y+titleNWPos.y)+5, 30, 20);
                if(titleNWOver >= 0){
                        g.setColor(new Color(0.975f, 0.975f, 0.975f));
                        g.fillRect((int)(titlePos.x+titleNWPos.x)+40*titleNWOver-10, (int)(titlePos.y+titleNWPos.y)+5, 30, 20);
                        }
                g.setColor(Color.black);
                for(int i = 0; i < 8; i++){
                        g.drawString("" + (i+1)*6, (int)(titlePos.x+titleNWPos.x)+40*i-10, (int)(titlePos.y+titleNWPos.y)+20);
                        }

                //draw the word length selection stuff
                g.drawString(titleWLStr, (int)(titlePos.x+titleWLPos.x), (int)(titlePos.y+titleWLPos.y));
                g.setColor(Color.white);
                g.fillRect((int)(titlePos.x+titleWLPos.x)+35*wordLengthSel-35, (int)(titlePos.y+titleWLPos.y)+5, 30, 20);
                if(titleWLOver >= 0){
                        g.setColor(new Color(0.975f, 0.975f, 0.975f));
                        g.fillRect((int)(titlePos.x+titleWLPos.x)+35*titleWLOver-35, (int)(titlePos.y+titleWLPos.y)+5, 30, 20);
                        }
                g.setColor(Color.black);
                for(int i = 0; i < 10; i++){
                        g.drawString("" + (i+4), (int)(titlePos.x+titleWLPos.x)+35*i-30, (int)(titlePos.y+titleWLPos.y)+20);
                        }

                //draw the time limit selection stuff
                g.drawString(titleTLStr, (int)(titlePos.x+titleTLPos.x), (int)(titlePos.y+titleTLPos.y));
                g.setColor(Color.white);
                g.fillRect((int)(titlePos.x+titleTLPos.x)+53*timeLimitSel+15, (int)(titlePos.y+titleTLPos.y)+5, 45, 20);
                if(titleTLOver >= 0){
                        g.setColor(new Color(0.975f, 0.975f, 0.975f));
                        g.fillRect((int)(titlePos.x+titleTLPos.x)+53*titleTLOver+15, (int)(titlePos.y+titleTLPos.y)+5, 45, 20);
                        }
                g.setColor(Color.black);
                g.drawString("   none   5:00   10:00   15:00   20:00", (int)(titlePos.x+titleTLPos.x), (int)(titlePos.y+titleTLPos.y)+20);

                //draw the play button
                g.setFont(new Font("monospaced", Font.PLAIN, 16));
                if(titlePlayOver){
                        g.setColor(Color.white);
                        g.fillRect(APP_W/2-40, (int)(titlePos.y+titlePlayPos.y)-15, 80, 25);
                        g.setColor(Color.black);
                        }
                g.drawString(titlePlayStr, (int)(titlePos.x+titlePlayPos.x), (int)(titlePos.y+titlePlayPos.y));

                g.setFont(new Font("monospaced", Font.PLAIN, 10));
                g.drawString(VERSION_STRING, APP_W-VERSION_STRING.length()*7, APP_H-5);
        }

        //draw the hiscore listing box
        void hiScoreListingDisplay(Graphics g)
        {
        }

        //tells if the hiscores list is currently showing
        boolean hiScoresListShowing()
        {
                return !gotHiScore && hiScoreEntryDone;
        }

        //draw the hiscore entry box
        void hiScoreEntryDisplay(Graphics g)
        {
        }

        //draw the game over screen
        void gameOverDisplay(Graphics g)
        {
        }

        //draw the "puzzle finished" screen
        void puzzleFinishedDisplay(Graphics g)
        {
                //draw the title menu
                g.setColor(new Color(0.9f, 0.9f, 0.9f, 0.9f));
                g.fillRect((int)puzzleFinishedPos.x+1, (int)puzzleFinishedPos.y+1, finishedPromptW-2, finishedPromptH-2);
                g.setColor(Color.black);
                g.drawRect((int)puzzleFinishedPos.x, (int)puzzleFinishedPos.y, finishedPromptW, finishedPromptH);

                g.setFont(new Font("monospaced", Font.PLAIN, 16));
                //draw shadows under the text
                g.setColor(new Color(0.825f, 0.825f, 0.825f));
                g.drawString("       ( puzzle completed! )", (int)puzzleFinishedPos.x+21, (int)puzzleFinishedPos.y+21);
                g.drawString("          ( total time )", (int)puzzleFinishedPos.x+21, (int)puzzleFinishedPos.y+61);
                g.drawString("           " + intNumberString(gameClock.mins, 2) + "mins " + intNumberString(gameClock.secs, 2) + "secs  ", (int)puzzleFinishedPos.x+16, (int)puzzleFinishedPos.y+81);
                g.drawString(" ( enter your name for posterity: )", (int)puzzleFinishedPos.x+21-4, (int)puzzleFinishedPos.y+131);
                //draw the text overlay
                g.setColor(Color.black);
                g.drawString("       ( puzzle completed! )", (int)puzzleFinishedPos.x+20, (int)puzzleFinishedPos.y+20);
                g.drawString("          ( total time )", (int)puzzleFinishedPos.x+20, (int)puzzleFinishedPos.y+60);
                g.drawString("           " + intNumberString(gameClock.mins, 2) + "mins " + intNumberString(gameClock.secs, 2) + "secs  ", (int)puzzleFinishedPos.x+15, (int)puzzleFinishedPos.y+80);
                g.drawString(" ( enter your name for posterity: )", (int)puzzleFinishedPos.x+20-4, (int)puzzleFinishedPos.y+130);

                //draw the name entry box
                g.setColor(new Color(0.6f, 0.6f, 0.6f));
                g.fillRect((int)puzzleFinishedPos.x+36, (int)puzzleFinishedPos.y+140, MAX_PLAYER_NAME_LENGTH*10, 20);

                //draw the current player name string
                g.setColor(Color.white);
                g.setFont(new Font("monospaced", Font.PLAIN, 14));
                g.drawString(playerNameString + "_", (int)puzzleFinishedPos.x+38, (int)puzzleFinishedPos.y+154);
        }

        //draw the title screen
        void quitPromptDisplay(Graphics g)
        {
                //draw the title menu
                g.setColor(new Color(0.9f, 0.9f, 0.9f));
                g.fillRect((int)quitPromptPos.x+1, (int)quitPromptPos.y+1, quitPromptW-2, quitPromptH-2);
                g.setColor(Color.black);
                g.drawRect((int)quitPromptPos.x, (int)quitPromptPos.y, quitPromptW, quitPromptH);

                //draw the logo
                g.setFont(new Font("monospaced", Font.PLAIN, 16));
                //draw the highlights for which buttons are being hovered over
                if(quitPromptYesOver){
                        g.setColor(Color.white);
                        g.fillRect((int)quitPromptPos.x+20, (int)quitPromptPos.y+50, 70, 20);
                        }
                else if(quitPromptNoOver){
                        g.setColor(Color.white);
                        g.fillRect((int)quitPromptPos.x+120, (int)quitPromptPos.y+50, 60, 20);
                        }
                g.setColor(Color.black);
                g.drawString("( really quit? )", (int)quitPromptPos.x+20, (int)quitPromptPos.y+20);
                g.drawString("( yes )   ( no )", (int)quitPromptPos.x+20, (int)quitPromptPos.y+64);
        }

        //draw the "time's up" screen
        void timeUpDisplay(Graphics g)
        {
                //draw the title menu
                g.setColor(new Color(0.9f, 0.9f, 0.9f));
                g.fillRect((int)timeUpPromptPos.x+1, (int)timeUpPromptPos.y+1, timeUpPromptW-2, timeUpPromptH-2);
                g.setColor(Color.black);
                g.drawRect((int)timeUpPromptPos.x, (int)timeUpPromptPos.y, timeUpPromptW, timeUpPromptH);

                //draw the logo
                g.setFont(new Font("monospaced", Font.PLAIN, 16));
                //draw the highlights for which buttons are being hovered over
                if(timeUpPromptYesOver){
                        g.setColor(Color.white);
                        g.fillRect((int)timeUpPromptPos.x+110, (int)timeUpPromptPos.y+65, 80, 20);
                        }
                else if(timeUpPromptNoOver){
                        g.setColor(Color.white);
                        g.fillRect((int)timeUpPromptPos.x+70, (int)timeUpPromptPos.y+85, 185, 20);
                        }
                g.setColor(Color.black);
                g.drawString("  ( time's up! )", (int)timeUpPromptPos.x+70, (int)timeUpPromptPos.y+40);
                g.drawString("    ( exit )", (int)timeUpPromptPos.x+70, (int)timeUpPromptPos.y+80);
                g.drawString("( continue anyway )", (int)timeUpPromptPos.x+70, (int)timeUpPromptPos.y+100);
        }

        //draw this string with a shadow beneath it..
        public void drawStringShadowed(Graphics g, String str, Color col, int x, int y, int xoff, int yoff)
        {
            g.setColor(Color.BLACK);
            g.drawString(str, x+xoff, y+yoff);
            g.setColor(col);
            g.drawString(str, x, y);
        }

        //display method (run() calls this each frame)
        void paintApp(Graphics g)
        {
                backgroundDisplay(g_scBuff);

                switch(gameState){
                        case GAMESTATE_TITLE: //draw the title screen
                                titleDisplay(g_scBuff);

                                break;
                        case GAMESTATE_INITIALIZE:
                                gameInitializationDisplay(g_scBuff);

                                break;
                        case GAMESTATE_READY:
                                //itemDisplay(g_scBuff, gameItem, MAX_ITEMS);
                                puzzleDisplay(g_scBuff, gamePuzzle);
                                playerDisplay(g_scBuff, gamePlayer, gamePuzzle);
                                clockDisplay(g_scBuff, gameClock, (int)hudClockPos.x, (int)hudClockPos.y, (gameClock.mins >= (timeLimitSel*5-1) && timeLimitSel > 0 ? Color.red : Color.black), 12);
                                particleDisplay(g_scBuff, gameParticleBank);
                                if(showQuitPrompt) quitPromptDisplay(g_scBuff);
                                else if(puzzleFinished) puzzleFinishedDisplay(g_scBuff);
                                else if(showTimeUpPrompt) timeUpDisplay(g_scBuff);

                                break;
                        case GAMESTATE_GAMEOVER: //draw the game over screen
                                gameOverDisplay(g_scBuff);

                                break;
                        default:
                                break;
                        }

                //draw the status/hud, etc.
                //foregroundDisplay(g_scBuff);

                //draw the screen buffer to screen
                g.drawImage(img_scBuff, 0, 0, this);
        }


        //handle player logic routines
        void playerLogic(player pl)
        {
        }

        //cross this word off
        public void crossOutPuzzleWord(String str)
        {
                System.out.println("cross from (" + gamePlayer.startX + ", " + gamePlayer.startY + ") to (" + gamePlayer.endX + ", " + gamePlayer.endY + ")");
                gamePuzzle.setNewCross(gamePlayer.startX, gamePlayer.startY, gamePlayer.endX, gamePlayer.endY);
                gamePuzzle.crossOutWord(str);
                if(gamePuzzle.allWordsCrossed()){
                        puzzleFinished = true;
                        }
        }

        //handle puzzle logic routines
        void puzzleLogic(player pl)
        {
        }

        //handle all item-related logic..
        void itemLogic(item it[], int numItems)
        {
        }

        //handle the title screen stuff
        void titleLogic()
        {
        }

        //handle the hiscore listing screen stuff
        void hiScoreDisplayLogic()
        {
        }

        //handle the game over screen stuff
        void gameOverLogic()
        {
        }

        //particle logic..
        void particleLogic(particleBank pb)
        {
            for(int i = 0; i < pb.numParticles; i++)
		        {
                if(pb.bParticle[i] != null && !pb.bParticle[i].isInactive())
			          {
                    pb.bParticle[i].logic();
			          }
		        }
        }

        //add the player's score/data to the hiscore bank
        void addNewHiScore()
        {
                gameHiScoreBank.addNewScore(0, gameHiScoreBank.SORT_BYSCORE, playerNameString, gameClock.getTimeMilliseconds(), (numWordsSel+1)*6, MIN_WORD_LENGTH+wordLengthSel);
                gameHiScoreBank.sort(0, gameHiScoreBank.SORT_BYSCORE);
                if(isOnline) saveHiScores();
        }

        //hiscore name entry completed, now let's finish up
        void finishHiScoreEntry()
        {
                //go back to the title screen after entering name
                hiScoreEntryDone = true;
                gotHiScore = false;
                addNewHiScore();
                puzzleFinished = false;
                gameState = GAMESTATE_TITLE_INITIALIZE;
                showQuitPrompt = false;
        }

        //initialize all the timers we're working with
        void initializeTimers()
        {
                //set the game clock up
                gameClock.reset();
        }

        //initialize the title screen stuff
        void initializeTitle()
        {
                showTimeUpPrompt = false;
                loadingPuzzle = false;
                showQuitPrompt = false;
                puzzleFinished = false;
                continueAnyway = false;
                debugOn = false;
        }

        //initialize the players
        void initializePlayers()
        {
                gamePlayer = new player(playerNameString);
        }

        //initialize the current game puzzle
        void initializePuzzle()
        {
                loadingPuzzle = true;
                puzzleFinished = false;
                showQuitPrompt = false;

                if(isOnline){
                        gamePuzzle = new puzzle();
                        gamePuzzle.loadFromDictionary(gameDictionary, MIN_WORD_LENGTH+wordLengthSel, (numWordsSel+1)*6);
                        //gamePuzzle.loadDummy(-1);
                        }
                else{
                        gamePuzzle = new puzzle();
                        gamePuzzle.loadFromDictionary(gameDictionary, MIN_WORD_LENGTH+wordLengthSel, (numWordsSel+1)*6);
                        }

                //let's see what letters are left over
                int letterCount = 0;
                System.out.print("Leftover letters: ");
                for(int r = 0; r < gamePuzzle.numRows; r++)
                {
                  for(int c = 0; c < gamePuzzle.numCols; c++)
                  {
                    if(!gamePuzzle.pTile[r][c].wordHere)
                    {
                      letterCount++;
                      System.out.print("" + gamePuzzle.pTile[r][c].aChar);
                    }
                  }
                }
                System.out.println("..." + letterCount);

                //if(isOnline){
                //        puzzFilename = "/wordMix/test.wml";
                //        gamePuzzle = new puzzle();
                //        gamePuzzle.loadFile(puzzFilename);
                //        //gamePuzzle.loadDummy(-1);
                //        }
                //gamePuzzle.setFont(g_scBuff, new Font("monospaced", Font.PLAIN, 10), 8, 14);
                gamePuzzle.setFont(g_scBuff, new Font("monospaced", Font.PLAIN, fontH), fontW, fontH);
                gamePuzzle.setPositions(new vertex(0, 0), new vertex(20, 8), APP_W, APP_H);
                loadingPuzzle = false;
        }

        //initialize the playfield stuff
        void initializePlayfield()
        {
        }

        //initialize the item-related stuff
        void initializeItems()
        {
        }

        //deinitialize the players
        void deinitializePlayers()
        {
        }

        //deinitialize the items
        void deinitializeItems()
        {
        }

        //handle the game timer/clock logic
        void timerLogic()
        {
                //handle item spawn timer
                //if(++itemSpawnTimer >= itemSpawnTimerEnd){
                //        spawnItem();
                //        itemSpawnTimer = 0;
                //        itemSpawnTimerEnd = (int)((float)Math.random()*(float)itemSpawnTimerScale)+50;
                //        }

                //update the game clock
                gameClock.update();

                //check to see if we're over the current time limit
                if(!continueAnyway && (gameClock.mins >= (5*timeLimitSel) && timeLimitSel > 0)){
                        showTimeUpPrompt = true;
                        }
        }

        //main logic stuff
        void updateApp()
        {
                //get the elapsed time slice
                long dt = gameAverageTimer.deltaT(System.currentTimeMillis());

                //convert to a float fraction of 1 sec
                float ft = (float)dt*0.001f;

                switch(gameState){
                        case GAMESTATE_TITLE_INITIALIZE:
                                initializeTitle();
                                gameState = GAMESTATE_TITLE;

                                break;
                        case GAMESTATE_TITLE:
                                titleLogic();

                                break;
                        case GAMESTATE_INITIALIZE:
                                initializePuzzle();
                                initializePlayfield();
                                initializeTimers();
                                initializePlayers();
                                initializeItems();
                                gotHiScore = false;
                                hiScoreEntryDone = false;
                                System.out.println("game initialized.. starting level..");
                                gameState = GAMESTATE_READY;

                                break;
                        case GAMESTATE_GAMEOVER_BEGIN:
                                deinitializePlayers();
                                deinitializeItems();
                                if(isOnline) checkForHiScores();

                                gameState = GAMESTATE_GAMEOVER;

                                break;
                        case GAMESTATE_GAMEOVER:
                                gameOverLogic();

                                break;
                        default:
                                //playerLogic(playerViper);
                                //itemLogic(gameItem, MAX_ITEMS);

                                //don't update the timers if we're paused
                                if(!showQuitPrompt && !puzzleFinished && !showTimeUpPrompt) timerLogic();
                                //handle particle logic
                                particleLogic(gameParticleBank);

                                break;
                        }
        }

        //  loadImageSync() from http://www.spacejack.org/games/dbufanim/
        //  credits to Mike Linkovich
        //
        //  Simple method to load & wait for image synchronously
        //  rather than deal with threading.  I find this is
        //  usually more useful, however if you needed to perform
        //  other tasks while loading, then you should take advantage
        //  of Java's asynchronous getImage loads.
        //
        Image loadImageSync(String imgFile)
        {
                MediaTracker mt;
                Image img;

                //  Start loading the graphics...
                //
                img = getImage(getCodeBase(), imgFile);
                mt = new MediaTracker(this);
                mt.addImage( img, 0 );

                //  Wait here 'till it's done
                //
                try
                {
                        mt.waitForAll();
                } catch(Exception e) { img = null; };

                if( img == null || img.getWidth(this) < 0 )
                System.err.println( "Failed to load image: '" + imgFile + "'" );

                return img;
        }

        //method for giving a string with a set number of "0" spaces (long)
        public String longNumberString(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
          }

        //method for giving a string with a set number of "0" spaces (int)
        public String intNumberString(int number, int length)
        {
                String temp_str = new String();
                int power = 0, temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Integer.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //check if we got any hiscores this game
        public void checkForHiScores()
        {
                gotHiScore = gameHiScoreBank.isHiScoreTime(0, gameClock.mins);
                if(gotHiScore) hiScoreEntryDone = false;
        }

        //save the current hiscores to file
        public void saveHiScores()
        {
                gameHiScoreBank.saveFile(0, "/cgi/wmwrite.pl");
        }

        //load hiscores from file
        public void loadHiScores()
        {
                gameHiScoreBank.loadFile(0, "/wordMix/hiscore.txt");
        }

        //start the application (graphics set-up, etc)
        public void beginApplication(Frame f, GraphicsDevice device)
        {
          boolean isFullscreen;
          isApplication = true;
          if(!useFullscreen){
            f.setSize(APP_W+10, APP_H+30);
          }
          else{
            isFullscreen = device.isFullScreenSupported();
            System.out.println("full screen support: " + isFullscreen);
            f.setUndecorated(isFullscreen);
            f.setResizable(!isFullscreen);
            if(isFullscreen){
                // Full-screen mode
                device.setFullScreenWindow(f);
                f.validate();
                }
            else{
                // Windowed mode
                //f.pack();
                f.setSize(APP_W+10, APP_H+30);
                f.setVisible(true);
                }
              }
            }



        //main loop (when used as application..)
      	public static void main(String args[])
      	{
      		final wordMix applet = new wordMix();
      		Frame f = new Frame(VERSION_STRING);
      		GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
      		GraphicsDevice device = env.getDefaultScreenDevice();

      		f.addWindowListener(new java.awt.event.WindowAdapter() {
      			public void windowClosing(java.awt.event.WindowEvent e) {
      				applet.stop();
      				applet.destroy();
      				System.exit(0);
      				};
      			});

      		f.add(applet, BorderLayout.CENTER);
      		applet.beginApplication(f, device);
      		f.show();
      		applet.init();    //initialize the applet
      		applet.start();
      	}
}
